from PyQt4 import Qt, QtCore, QtGui
from taurus.qt.qtgui.resource import getThemeIcon
import panic, fandango

class aacWidget(QtGui.QWidget):
    def __init__(self,parent=None,container=None):
        QtGui.QWidget.__init__(self,parent)
        self._aacwi = alarmattrchangeForm()
        self._aacwi.alarmattrchangeSetupUi(self)
        self._kontainer = container
        self.setAlarmCombo()

    def setAlarmCombo(self):
        self._aacwi.setAlarmCombo()

    def show(self):
        QtGui.QWidget.show(self)
        
class alarmattrchangeForm(object):
    api=None
    def __init__(self,api=None):
        type(self).api = api or self.api or panic.current()
        object.__init__(self)
        
    def alarmattrchangeSetupUi(self, Form):
        Form.setObjectName("Form")
        self.GridLayout = QtGui.QGridLayout(Form)
        self.GridLayout.setObjectName("GridLayout")
        self.alarmCombo = QtGui.QComboBox(Form)
        self.alarmCombo.setObjectName("alarmCombo")
        self.GridLayout.addWidget(self.alarmCombo, 0, 0, 1, 1)
        self.tableWidget = QtGui.QTableWidget(Form)
        self.tableWidget.setObjectName("tableWidget")
        self.GridLayout.addWidget(self.tableWidget, 1, 0, 1, 1)
        self.refreshButton = QtGui.QPushButton(Form)
        self.refreshButton.setObjectName("refreshButton")
        self.GridLayout.addWidget(self.refreshButton, 2, 0, 1, 1)
        self.retranslateUi(Form)
        QtCore.QMetaObject.connectSlotsByName(Form)

    def retranslateUi(self, Form):
        Form.setWindowTitle(QtGui.QApplication.translate("Form", "Alarm Attribute Changer", None, QtGui.QApplication.UnicodeUTF8))
        self.refreshButton.setText(QtGui.QApplication.translate("Form", "Refresh", None, QtGui.QApplication.UnicodeUTF8))
        self.refreshButton.setIcon(getThemeIcon("view-refresh"))
        self.refreshButton.setToolTip("Refresh list")
        QtCore.QObject.connect(self.tableWidget, QtCore.SIGNAL("itemChanged(QTableWidgetItem *)"), self.onEdit)
        QtCore.QObject.connect(self.alarmCombo, QtCore.SIGNAL("currentIndexChanged(QString)"), self.buildList)
        QtCore.QObject.connect(self.refreshButton, QtCore.SIGNAL("clicked()"), self.buildList)
        Form.resize(430, 600)

    def setAlarmCombo(self):
        alarmList=self.api.alarms.values()
        for a in alarmList:
            self.alarmCombo.addItem(QtCore.QString(a.tag)+" ("+QtCore.QString(a.device)+")")
        self.alarmCombo.model().sort(0, Qt.Qt.AscendingOrder)

    def buildList(self):
        self.tableWidget.blockSignals(True)
        alarm=str(self.alarmCombo.currentText().split(' ')[0]).strip(' ')
        device=str(self.alarmCombo.currentText().split(' ')[1]).strip(')(')
        data=[]
        try:
            prop=panic.getAlarmDeviceProperty(device, 'AlarmConfigurations')[0]
            data=prop.split(alarm,1)[1].strip(':').split(';',len(panic.ALARM_CONFIG)-1) if alarm in prop else None
        except Exception,e:
            print('Exception!', e)
        #data = alarm in prop and prop.split(alarm,1)[1].strip(':').split(';',len(panic.ALARM_CONFIG)-1) or ''
        if data:
            data.pop()
            rows=len(data)
            cols=2
            self.tableWidget.setColumnCount(cols)
            self.tableWidget.setRowCount(rows)
            self.tableWidget.setHorizontalHeaderLabels(["Attribute Name", "Attribute Value"])
            for row in range(0, rows):
                for col in range(0, cols):
                    if (col==0):
                        item=QtGui.QTableWidgetItem("%s" % data[row].split('=')[col])
                        item.setFlags(QtCore.Qt.ItemIsEnabled)
                    else:
                        item=QtGui.QTableWidgetItem("%s" % data[row].split('=')[col])
                        if row%2==0:
                            item.setBackgroundColor(QtGui.QColor(225,225,225))
                    self.tableWidget.setItem(row, col, item)
        self.tableWidget.resizeColumnsToContents()
        self.tableWidget.blockSignals(False)

    def onEdit(self):
        row=self.tableWidget.currentRow()+1
        alarm=str(self.alarmCombo.currentText().split(' ')[0]).strip(' ')
        device=str(self.alarmCombo.currentText().split(' ')[1]).strip(')(')
        properties=str(panic.getAlarmDeviceProperty(device, 'AlarmConfigurations'))
        prop=(str(self.tableWidget.item(row-1,0).text()))
        value=(str(self.tableWidget.item(row-1,1).text()))
        flag, pos = 0, 0
        data=properties.split(';')
        data.pop()
        for p in data:
            if (p.strip("'[").startswith(alarm)):
                flag=1
            if (p.startswith(prop+'=') and flag==1):
                new=prop+"="+value
                data[pos]=new
                break
            pos=pos+1
            tmp=';'
            tmp=tmp.join(data)
            tmp=tmp.strip("'[")+';'
            ptype=fandango.device.cast_tango_type(panic.PyAlarmDefaultProperties[prop][0]).__name__
            if(value):
                if(ptype=='int'):
                    try:
                        y = int(value)
                        panic.setAlarmDeviceProperty(device, 'AlarmConfigurations', tmp)
                    except Exception,e:
                        print('Exception!', e)
                elif(ptype=='bool'):
                    try:
                        y = bool(value)
                        panic.setAlarmDeviceProperty(device, 'AlarmConfigurations', tmp)
                    except Exception,e:
                        sprint('Exception!', e)
                else:
                    panic.setAlarmDeviceProperty(device, 'AlarmConfigurations', tmp)
        #print(tmp)
        self.buildList()

if __name__ == "__main__":
    import sys
    app=QtGui.QApplication(sys.argv)
    Form=QtGui.QWidget()
    ui=alarmattrchangeForm()
    ui.alarmattrchangeSetupUi(Form)
    Form.show()
    ui.setAlarmCombo()
    sys.exit(app.exec_())